import java.lang.*;
import java.util.*;

class Basket {

	/**
	 *  Tapes customer is about to rent
	 */
	private Vector tapes_;
	public Vector tapes() { return tapes_; }
	public void tapes( Vector aVector ) { tapes_ = aVector; }

    Basket() {
        this.initialize();
    }

    private void initialize() {
        this.tapes(new Vector());
    }

    public int tapeCount() {
        return this.tapes().size();
    }

    public Tape leastExpensive() {

        Tape cheapest = null;
        double cheapestPrice = 9999.99;

        Enumeration theTapes = this.tapes().elements();
        while (theTapes.hasMoreElements()) {
            Tape aTape = (Tape) theTapes.nextElement();
            if (aTape.rentalPrice() < cheapestPrice) {
                cheapestPrice  = aTape.rentalPrice();
                cheapest = aTape;
            }
        }
        return cheapest;
    }

    public double regularCost() {

        double total = 0.0;

        Enumeration theTapes = this.tapes().elements();
        while (theTapes.hasMoreElements()) {
            Tape aTape = (Tape) theTapes.nextElement();
            total += aTape.rentalPrice();
        }

        return total;
    }

    public Vector tapesToCheckout() {
        return this.tapes();
    }

}