import java.lang.*;
import java.util.*;

class Bank extends Observable {

    private String name_;
    public String name() { return name_; }
    public void name(String aName) { name_ = aName; }

    private Vector accounts_;
    public Vector accounts() { return accounts_; }
    public void accounts(Vector accountSet) { accounts_ = accountSet; }

    private Date today_;
    public Date today() { return today_; }
    public void today(Date aDate) { today_ = aDate; }

    private TransactionStore transactionStore_;
    public TransactionStore transactionStore() { return transactionStore_; }
    public void transactionStore(TransactionStore theTS) { transactionStore_ = theTS; }

    private TransactionLog transactionLog_;
    public TransactionLog transactionLog() { return transactionLog_; }
    public void transactionLog(TransactionLog theTL) { transactionLog_ = theTL; }


    Bank() {
        this.initialize();
    }

    private void initialize() {
        this.accounts(new Vector());
        this.today(new Date());
        this.name("Bank of Antartica");
        this.transactionStore(new TransactionStore());
        this.transactionLog(new TransactionLog());
    }

    public void publicize(String aString) {
        this.setChanged();
        this.notifyObservers(aString);
    }

    public void processTransactions() {

        Transaction aTransaction = this.transactionStore().getNext();

        while(aTransaction != null) {
            this.processTransaction(aTransaction);
            aTransaction = this.transactionStore().getNext();
        }

        this.transactionLog().processLog();
    }

    public void processTransaction(Transaction aTransaction) {

        this.transactionLog().addTransaction(aTransaction);

        aTransaction.updateAccount();

        String output = "AccountName="    + aTransaction.customerName() +
                        "  Amount="       + aTransaction.amount() + "\n" +
                        "  Date="         + aTransaction.timestamp() +
                        "  Balance="      + aTransaction.account().balance() +"\n" ;
        this.publicize(output);


    }

}