import java.lang.*;
import java.util.*;

class Bank extends Observable {

    private String name_;
    public String name() { return name_; }
    public void name(String aName) { name_ = aName; }

    private Hashtable accounts_;
    public Hashtable accounts() { return accounts_; }
    public void accounts(Hashtable accountSet) { accounts_ = accountSet; }

    private Date today_;
    public Date today() { return today_; }
    public void today(Date aDate) { today_ = aDate; }

    private TransactionLog transactionLog_;
    public TransactionLog transactionLog() { return transactionLog_; }
    public void transactionLog(TransactionLog theTL) { transactionLog_ = theTL; }

    private int numberOfTransactions_;
    public int numberOfTransactions() { return numberOfTransactions_; }
    public void numberOfTransactions(int i) { numberOfTransactions_ = i; }

    private double cashFlow_;
    public double cashFlow() { return cashFlow_; }
    public void cashFlow(double i) { cashFlow_ = i; }


    Bank() {
        this.initialize();
    }

    private void initialize() {
        this.accounts(new Hashtable());

        CheckingAccount a = new CheckingAccount();
        a.customerName("Fred");
        a.id("100");
        a.balance(66360.0);
        this.accounts().put(a.id(),a);

        CheckingAccount b = new CheckingAccount();
        b.customerName("Bill");
        b.id("101");
        b.balance(22.5);
        this.accounts().put(b.id(),b);

        this.today(new Date());
        this.name("Bank of Antartica");
       // this.transactionStore(new TransactionStore(this));
        this.transactionLog(new TransactionLog());
    }

    public Account getAccount(String accountID){
        return (Account) this.accounts().get(accountID);
    }
    public boolean verifyAccount(String accountID){
        return this.accounts().containsKey(accountID);
    }
    public void publicize(String aString) {
        this.setChanged();
        this.notifyObservers(aString);
    }

    public Vector processLog(){
        return this.transactionLog().processLog();
    }


    public void startNewTransactionGenerator(){
        new TransactionGenerator(this);
    }

    public void processTransaction(Transaction aTransaction) {

        this.transactionLog().addTransaction(aTransaction);
        this.cashFlow( this.cashFlow() + aTransaction.amount() );
        this.numberOfTransactions(this.numberOfTransactions()+1) ;

        aTransaction.updateAccount();

        String output = aTransaction.toString();
        this.publicize(output);


    }

}