
import java.lang.*;
import java.util.*;

class Analyzer implements Runnable {

    private boolean busy_;
    public boolean busy() { return busy_ ; }
    public void busy(boolean aBoolean) { busy_ = aBoolean ; }

    private boolean done_;
    public boolean done() { return done_ ; }
    public void done(boolean aBoolean) { done_ = aBoolean ; }

    private Thread thread_;
    public Thread thread() { return thread_ ; }
    public void thread(Thread aThread) { thread_ = aThread ; }

    private Graph graph_;
    public Graph graph() { return graph_; }
    public void graph(Graph aGraph) { graph_ = aGraph; }

    public Analyzer() {
        this.initialize();
    }

    private void initialize() {
        this.graph(new Graph("Analyzer Graph"));
        this.busy(false);
        this.done(false);
        this.thread(new Thread(this)); // define the thread but
                                       // do not start it
    }

    public void run() {

        System.out.println("Analyzer run");

        // fill up arrays
        double[] xData = new double[100];
        double[] yData = new double[1];

        for (int i=0; i<100; i++) {
            xData[i] = i;
        }

        yData[0] = 1.0;
        this.graph().ySeries(yData);
        this.graph().xSeries(xData);

        // begin plotting
        while (!(this.done())) {

            this.graph().plot();

            double newValue = Math.random();

            this.graph().addYPoint(newValue);

            try {
                Thread.sleep(250);
            }
            catch(InterruptedException e) {
                System.out.println("I have been interrupted");
            }

            if (this.graph().ySeries().length == 100)
                this.done(true);
        }

        this.busy(false);
    }

}
