import java.awt.*;
import java.lang.*;
import java.util.*;
import java.net.*;
import java.io.*;

public class PortHandler {

    private SerialPort serialPort_;
    public SerialPort serialPort() { return serialPort_; }
    public void serialPort (SerialPort thePort) {serialPort_ = thePort; }

    PortHandler() {
        this.initialize();
    }

    private void initialize() {

        int port = 1;

    	try {
    	    port = 1;
        	SerialConfig serCfg = new SerialConfig(port);
        	this.serialPort(new SerialPort(serCfg));
        	int verLib = this.serialPort().getLibVer();
        	short vMajor = (short)(verLib >> 16);
        	short vMinor = (short)(verLib & 0xffff);
    		String slVerMsg = "Shared Library version: "+vMajor+"."+vMinor;
       		System.out.println("COM"+port+": Initialized. "+slVerMsg);
    		this.serialPort().setDTR(false);
    		this.serialPort().setRTS(false);
        }
        catch (IOException e) {
            System.out.println("COM"+port+": Failed to initialize port");
            port = 0;
        }
        catch (Exception e) {
            System.out.println(e.toString());
        }
    }


    public void waitForResponse() {
        try {Thread.sleep(500);} catch (InterruptedException e) {}
    }


    public void waitForUpdate() {
        String aString = null;

        aString = this.getText();

        while (aString.indexOf("*") == -1) {
            aString = this.getText();
        }
    }


    public void putText(String theText) {
        int theLength = theText.length();

        try {
            this.serialPort().putData(theText.getBytes(), theLength);
        } catch (IOException e) {System.out.println("IO Error in putText"); }
	}

    public String getText() {

        String theString = null;
        byte[] theBytes = null;

        try {
            theBytes = new byte[this.serialPort().rxAvail()];
            int theCount = this.serialPort().getData(theBytes);
            theString = new String (theBytes, 0, theCount);
  //          System.out.println ("Count = " + theCount);
        } catch (IOException e) {System.out.println("IO Error in getText"); }

		return theString;
	}
}
