import java.lang.*;
import java.util.*;

class PriceCalculator {

	/**
	 *  Resolves promotion pricing issues
	 */
	private PromotionResolver promotionResolver_;
	public PromotionResolver promotionResolver() { return promotionResolver_; }
	public void promotionResolver( PromotionResolver aPromotionResolver ) { promotionResolver_ = aPromotionResolver; }

	/**
	 *  Promotions for this store .. includes ones that are not active
	 */
	private Hashtable promotions_;
	public Hashtable promotions() { return promotions_; }
	public void promotions( Hashtable anHT ) { promotions_ = anHT; }

    PriceCalculator () {
        this.initialize();
    }

    private void initialize() {
        this.promotionResolver(new PromotionResolver());
        this.promotions(new Hashtable());
        this.setupPromotions();
    }

    public void setupPromotions() {

        // PromoThursday
        PromoThursday p1 = new PromoThursday();
        this.promotions().put(p1.name(), p1);

        // PromoKids
        PromoKids p2 = new PromoKids();
        this.promotions().put(p2.name(), p2);

    }

    public Enumeration promotionNames() {
        return this.promotions().keys();
    }

    public double calculatePrice( Vector promoNames, Customer aCustomer){
        System.out.println("calculatePrice in PriceCaluculator");
        Vector promos = new Vector();
        Enumeration enum = promoNames.elements();
        while( enum.hasMoreElements() ){
            String aPromoName = (String) enum.nextElement();
            promos.addElement(this.promotions().get(aPromoName));
        }

        this.promotionResolver().setActivePromotions( promos );
        return this.promotionResolver().computeBestPrice(aCustomer);
    }

}