import java.text.*;
import java.util.*;

class CoinCounter extends Observable implements Observer {

	/*
	*/
	private ChangeDispenser changeDispenser_;
	public ChangeDispenser changeDispenser() { return changeDispenser_; }
	public void changeDispenser( ChangeDispenser aChangeDispenser ) { changeDispenser_ = aChangeDispenser; }

	/*
	*/
	private CoinBucket coinBucket_;
	public CoinBucket coinBucket() { return coinBucket_; }
	public void coinBucket( CoinBucket aCoinBucket ) { coinBucket_ = aCoinBucket; }

	/*
	*/
	private int amountDeposited_;
	public int amountDeposited() { return amountDeposited_; }
	public void amountDeposited( int aint ) { amountDeposited_ = aint; }


	CoinCounter() {
	    this.initialize();
	}

	private void initialize() {
	    this.changeDispenser(new ChangeDispenser());
	    this.amountDeposited(0);
	    // coinbucket is hooked up by vending machine
	}

    public void bankCoins() {
        this.coinBucket().storeCoins();
    }

    public boolean moneyRequired (int amount) {
        return (amount <= this.amountDeposited());
    }

    public void update (Observable obs, Object o) {
        int amount = ((Integer) o).intValue();
        this.amountDeposited(amount);

        double viewableAmount = amount / 100.0;
        NumberFormat theNF = NumberFormat.getCurrencyInstance();

        String amountString = theNF.format(viewableAmount);
        this.publicize(amountString);
    }
	public void publicize(String amountDeposited){
	    System.out.println("publicize in CoinCounter");
	    this.setChanged();
	    this.notifyObservers(amountDeposited);
	}


}
