import java.lang.*;
import java.util.*;

class Dispenser {

	/*
	*/
	private DispenseButton dispenseButton_;
	public void dispenseButton( DispenseButton aDispenseButton ) { dispenseButton_ = aDispenseButton; }
	public DispenseButton dispenseButton() { return dispenseButton_; }

	/*
	*/
	private DispenserGate dispenserGate_;
	public void dispenserGate( DispenserGate aDispenserGate ) { dispenserGate_ = aDispenserGate; }
	public DispenserGate dispenserGate() { return dispenserGate_; }

	/*
	*/
	private SoldOutSensor soldOutSensor_;
	public SoldOutSensor soldOutSensor() { return soldOutSensor_; }
	private void soldOutSensor( SoldOutSensor aSoldOutSensor ) { soldOutSensor_ = aSoldOutSensor; }

	/*
	*/
	private CoinCounter coinCounter_;
	public CoinCounter coinCounter() { return coinCounter_; }
	public void coinCounter( CoinCounter aCoinCounter ) { coinCounter_ = aCoinCounter; }

	/*
	*/
	private int drinkPrice_;
	public int drinkPrice() { return drinkPrice_; }
	public void drinkPrice( int aPrice ) { drinkPrice_ = aPrice; }

	/**
	 *  The name of this Dispenser. This is used to identify
	 *  a particular Dispenser
	 */
	private String name_;
	public String name() { return name_; }
	public void name( String aString ) { name_ = aString; }

	Dispenser() {
	    this.initialize();
	}

	Dispenser(String aName) {
	    this();
	    this.name(aName);
	}

	private void initialize() {
	    this.dispenseButton(new DispenseButton());
	    this.dispenserGate(new DispenserGate());
	    this.soldOutSensor(new SoldOutSensor());
	 //   this.coinCounter(new CoinCounter());
	    this.drinkPrice(35);

	    this.soldOutSensor().updateSoldOutLite();
	}

	public void dispenseButtonPressed() {

	    if (this.soldOutSensor().isOn()) return;

	    if( this.coinCounter().moneyRequired (this.drinkPrice())) {

	        this.coinCounter().changeDispenser().dispenseChange(
	                            this.coinCounter().amountDeposited() -
	                                                      this.drinkPrice());
	        this.dispenserGate().releaseOne();

	        this.coinCounter().bankCoins();

	        this.soldOutSensor().updateSoldOutLite();

	    }
	}
}
