import java.lang.*;
import java.util.*;
import java.awt.*;
import java.io.*;

class LightAssistant extends Observable {

    private LightStateMachine lightStateMachine_;
    public  LightStateMachine lightStateMachine () { return lightStateMachine_; }
    public  void lightStateMachine (LightStateMachine anLSM) { lightStateMachine_ = anLSM; }

    LightAssistant(){ this.initialize(); }

    public void initialize() {
        this.lightStateMachine(new LightStateMachine());
    }

    public void update(Observable obs, Object o){
    }

    public void publicize(String s){
        this.setChanged();
        this.notifyObservers(s);
    }

    public void parentOnRequest () {
        System.out.println("Parent On Request");
        this.lightStateMachine().currentState().parentOn(this);
    }

    public void parentOffRequest () {
        System.out.println("Parent Off Request");
        this.lightStateMachine().currentState().parentOff(this);
    }

    public void childOnRequest () {
        System.out.println("Child On Request");
        this.lightStateMachine().currentState().childOn(this);
    }

    public void childOffRequest () {
        System.out.println("Child Off Request");
        this.lightStateMachine().currentState().childOff(this);
    }

    public void releaseRequest () {
        System.out.println("Release Request");
        this.lightStateMachine().currentState().release(this);
    }

    public void turnLightOn() {
        System.out.println("Light On");
    }

    public void turnLightOff() {
        System.out.println("Light Off");
    }
}
