import java.lang.*;
import java.util.*;
import java.io.*;

class LightStateMachine {

    private LAState currentState_;
    public LAState currentState() { return currentState_; }
    public void currentState (LAState aState) { currentState_ = aState; }

    private Hashtable stateDictionary_;
    public Hashtable stateDictionary() { return stateDictionary_; }
    public void stateDictionary (Hashtable aDict) { stateDictionary_ = aDict; }

    LightStateMachine() {
        this.initialize();
    }

    public void initialize() {
        this.stateDictionary( new Hashtable() );

        // create the state instances
        // and put them in the stateDictionary

        this.stateDictionary().put("parentOn",  (new LAStateParentOn()));
        this.stateDictionary().put("parentOff", (new LAStateParentOff()));
        this.stateDictionary().put("childOn",   (new LAStateChildOn()));
        this.stateDictionary().put("childOff",  (new LAStateChildOff()));

        this.currentState (this.changeState("childOff"));
    }

    public LAState changeState (String nextState) {

      //  System.out.println("Next state = " + nextState);

        LAState theNextState = (LAState) this.stateDictionary().get (nextState);
        this.currentState(theNextState);
        if (theNextState == null) System.out.println("invalid string " + nextState);
        return theNextState;
    }
}

