import java.awt.*;
import java.awt.event.*;
import java.util.*;

class MediatorDemoView extends SCView {

    MediatorDemoView(){
        super("Mediator Demo View");
        this.initialize();
    }

    public static void main(String argv[]){
        MediatorDemoView theMediatorDemoView = new MediatorDemoView();
        theMediatorDemoView.show();
    }

    private void initialize(){

        this.setLayout(null);

        this.initMenu();

        this.initWidgets();

        this.setSize(450,360);
        this.setLocation(80,80);

    }
    private void initWidgets(){
        this.addWidget("nickel Button", new NickelButton(this));
        this.addWidget("shadow Button", new ShadowButton(this));
        this.addWidget("type in me TextField", new TypeInMeTextField(this));
        this.addWidget("the only Label", new TheOnlyLabel());

    }
    private void initMenu(){
        MenuBar aMenuBar = new MenuBar();


            Menu aMenu = new Menu("File");
                MenuItem aMenuItem = new MenuItem("Exit");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Exit");
            aMenu.add(aMenuItem);

        aMenuBar.add(aMenu);

        this.setMenuBar(aMenuBar);
    }
   public void actionPerformed(ActionEvent e){
        String actionCommand = e.getActionCommand();
        if( actionCommand.equals("Exit") ){
            this.exit();
            return;
        }
    }


    public void windowClosing(WindowEvent we){
        this.exit();
    }
    private void exit(){
        System.out.println("closing MediatorDemoView");
        try{ Thread.sleep(500); }
        catch(InterruptedException ie){}
        this.dispose();
        System.exit(0);
    }




    //      the following methods act as the interface to the
    //      Mediator aspect of MediatorDemoView
    public void enterPressedInTextField(){
        this.getWidget("shadow Button").setEnabled(true);
        ((Label) this.getWidget("the only Label")).setText("Now Shadow Buttom Works");
        ((TextField) this.getWidget("type in me TextField")).setText("Nickel disables Shadow Button");
    }

    public void nickelButtonPressed(){
        this.getWidget("shadow Button").setEnabled(false);
        ((Label) this.getWidget("the only Label")).setText("Now Shadow Buttom Doesn't Work");
        ((TextField) this.getWidget("type in me TextField")).setText("Enter to enable Shadow Button");

    }
    public void shadowButtonPressed(){
        ((TheOnlyLabel) this.getWidget("the only Label")).setText("Shadow Button was Pressed");
        ((NickelButton) this.getWidget("nickel Button")).move();
    }


}

