import java.lang.*;
import java.util.*;

class MoneySlot extends Observable {

	/*
	*/
	private CoinCounter coinCounter_;
	public CoinCounter coinCounter() { return coinCounter_; }
	public void coinCounter( CoinCounter aCoinCounter ) { coinCounter_ = aCoinCounter; }

	/*
	*/
	private CoinBucket coinBucket_;
	public CoinBucket coinBucket() { return coinBucket_; }
	public void coinBucket( CoinBucket aCoinBucket ) { coinBucket_ = aCoinBucket; }

	MoneySlot() {
	    this.initialize();
	}

	private void initialize() {
	    this.coinCounter(new CoinCounter());
	    // coinBucket hooked up in vending machine
	}

	public void coinReceived(Coin aCoin) {
	    System.out.println("coinReceived in MoneySlot");
	    this.coinBucket().addCoin(aCoin);
	    this.publicize();
	}

	public void publicize(){
	    this.setChanged();
	    this.notifyObservers();
	}
}
