import java.lang.*;
import java.util.*;

class PromoTuesday extends Promotion{

    PromoTuesday() {
        this.initialize();
    }

    private void initialize() {
        this.name("Tuesday 2 for 1");
        this.description("If the customer rents" +
              " two tapes on Tuesday he gets one free");
        this.id("a");
        this.active(true);
    }

    public double promoPrice(Customer aCustomer) {

        // is it Tuesday ?

        int weekday = Calendar.getInstance().get(Calendar.DAY_OF_WEEK);
        if (weekday != 3){ // 1 is Sun, 2 is Mon, 3 is .........
        System.out.println("result from Tuesday = " + Double.POSITIVE_INFINITY);
            return Double.POSITIVE_INFINITY;
        }

        // now check if at least two tapes are being purchased
        // here we do not care if they are any category
        // but we could check ..


        if (aCustomer.numberOfTapesToCheckout() < 2){
        System.out.println("result from Tuesday = " + Double.POSITIVE_INFINITY);
            return Double.POSITIVE_INFINITY;
        }

        // well we have satisfied the requirements so let us now
        // find the cheapest tape and give it free
        Tape cheapest = aCustomer.cheapestTapeToCheckout();
        double result = aCustomer.normalPriceOfTapesToCheckout()
                                          - cheapest.rentalPrice();

        System.out.println("result from Tuesday = " + result);
        return result;
    }

    public boolean applicable(Customer aCustomer) {
        return true;
    }

}