import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

class ServerView extends SCView {

	/**
	 *  The Server for this View
	 */
	private Server server_;
	public Server server() { return server_; }
	public void server( Server aServer ) { server_ = aServer; }

    ServerView(String windowName){
        super(windowName);
        this.initialize();
    }

    public static void main(String argv[]){
        System.out.println(" starting ServerView ");
        ServerView theServerView =
                          new ServerView("Exception Handling Test");
        theServerView.show();
    }

    private void initialize(){

        this.addWindowListener(this);

        MenuBar aMenuBar = new MenuBar();

        Menu aMenu = new Menu("File");

        MenuItem aMenuItem = new MenuItem("Open");
        aMenuItem.addActionListener(this);
        aMenuItem.setActionCommand("OPEN");
        aMenu.add(aMenuItem);

        aMenuItem = new MenuItem("Exit");
        aMenuItem.addActionListener(this);
        aMenuItem.setActionCommand("EXIT");
        aMenu.add(aMenuItem);

        aMenuBar.add(aMenu);

        this.setMenuBar(aMenuBar);

        this.server(new Server());

        this.hookUpObservers();

        this.resize(200,150);

    }

    public void actionPerformed(ActionEvent e){
        if(e.getActionCommand() == "OPEN"){
                this.open();
                this.repaint();
        }

        if(e.getActionCommand() == "EXIT"){
            this.dispose();
            System.exit(0);
        }
    }

    public void hookUpObservers(){
        this.server().addObserver(this);
    }

    public void open() {
        this.server().startTheEngine();
    }

    public void update(Graphics g) { paint(g); }

    public void update(Observable obs, Object o) {
        this.repaint();
    }

   public boolean handleEvent(Event e) {
      if (e.id == Event.WINDOW_DESTROY)
      {
         this.hide();
         this.dispose();
         System.exit(0);
      }
      return true;
   }
    public void windowActivated(WindowEvent e){}

    public void windowClosed(WindowEvent e){}

    public void windowClosing(WindowEvent e){
        // this.kauffmanTest().done(true);
        try { Thread.sleep(2000); }
        catch(InterruptedException ie){}
        this.dispose();
        System.exit(0);

    }

    public void windowOpened(WindowEvent e){}

    public void windowDeactivated(WindowEvent e){}

    public void windowIconified(WindowEvent e){}

    public void windowDeiconified(WindowEvent e){}


}
