import java.util.*;

class TrafficLiteSimulator {

	/**
	 */
	private TrafficLiteSimulatorView trafficLiteSimulatorView_;
	public TrafficLiteSimulatorView trafficLiteSimulatorView() { return trafficLiteSimulatorView_; }
	public void trafficLiteSimulatorView( TrafficLiteSimulatorView aTLSView ) { trafficLiteSimulatorView_ = aTLSView; }

    private static int BEATTIME = 200; // milliseconds


	/**
	 *  The TLCAdapter associated with this TrafficLiteSimulator
	 */
	private TLCAdapter tlcAdapter_;
	public TLCAdapter tlcAdapter() { return tlcAdapter_; }
	public void tlcAdapter( TLCAdapter aTLCAdapter ) { tlcAdapter_ = aTLCAdapter; }

    TrafficLiteSimulator(TrafficLiteSimulatorView aView){
        this();
        this.trafficLiteSimulatorView( aView );
    }
    TrafficLiteSimulator(){
        this.initialize();

    }
    private void initialize() {

        this.tlcAdapter(new TLCAdapter());
        this.tlcAdapter().trafficLiteSimulator(this); // hookup the reverse reference
    }

    public void updateSimulator(String widgetName, String command){
        this.trafficLiteSimulatorView().update(widgetName, command);

    }
    public void instructLight(String widgetName, String command){
        this.trafficLiteSimulatorView().update(widgetName, command);

    }

    public void nPedLite(String s){
        this.updateView("NPedLight1",s);
        this.updateView("NPedLight2",s);
    }
    public void sPedLite(String s){
        this.updateView("SPedLight1",s);
        this.updateView("SPedLight2",s);
    }
    public void ePedLite(String s){
        this.updateView("EPedLight1",s);
        this.updateView("EPedLight2",s);
    }
    public void wPedLite(String s){
        this.updateView("WPedLight1",s);
        this.updateView("WPedLight2",s);
    }

    public void northThruLite(String s){
        this.updateView("NSLight",s);
    }
    public void northLeftLite(String s){
        this.updateView("NLLight",s);
    }
    public void southThruLite(String s){
        this.updateView("SSLight",s);
    }
    public void southLeftLite(String s){
        this.updateView("SLLight",s);
    }
    public void eastThruLite(String s){
        this.updateView("ESLight",s);
    }
    public void eastLeftLite(String s){
        this.updateView("ELLight",s);
    }
    public void westThruLite(String s){
        this.updateView("WSLight",s);
    }
    public void westLeftLite(String s){
        this.updateView("WLLight",s);
    }

    private void updateView(String widgetName, String command){
        this.trafficLiteSimulatorView().update(widgetName, command);
    }

    public void sensorButtonPressed(String actionCommand){
     //   System.out.println("sensorButtonPressed in TrafficLiteSimulator " + actionCommand);
        if( actionCommand.equals( "ns" ) ){
            this.tlcAdapter().nThruTrig();
            return;
        }
        if( actionCommand.equals( "nl" ) ){
            this.tlcAdapter().nLeftTrig();
            return;
        }
        if( actionCommand.equals( "ss" ) ){
            this.tlcAdapter().sThruTrig();
            return;
        }
        if( actionCommand.equals( "sl" ) ){
            this.tlcAdapter().sLeftTrig();
            return;
        }
        if( actionCommand.equals( "es" ) ){
            this.tlcAdapter().eThruTrig();
            return;
        }
        if( actionCommand.equals( "el" ) ){
            this.tlcAdapter().eLeftTrig();
            return;
        }
        if( actionCommand.equals( "ws" ) ){
            this.tlcAdapter().wThruTrig();
            return;
        }
        if( actionCommand.equals( "wl" ) ){
            this.tlcAdapter().wLeftTrig();
            return;
        }
    }
    public void pedestrianButtonPressed(String actionCommand){
        if( actionCommand.equals( "nw" ) ){
            this.tlcAdapter().nwPedTrig();
            return;
        }
        if( actionCommand.equals( "ne" ) ){
            this.tlcAdapter().nePedTrig();
            return;
        }
        if( actionCommand.equals( "sw" ) ){
            this.tlcAdapter().swPedTrig();
            return;
        }
        if( actionCommand.equals( "se" ) ){
            this.tlcAdapter().sePedTrig();
            return;
        }
        if( actionCommand.equals( "wn" ) ){
            this.tlcAdapter().wnPedTrig();
            return;
        }
        if( actionCommand.equals( "ws" ) ){
            this.tlcAdapter().wsPedTrig();
            return;
        }
        if( actionCommand.equals( "en" ) ){
            this.tlcAdapter().enPedTrig();
            return;
        }
        if( actionCommand.equals( "es" ) ){
            this.tlcAdapter().esPedTrig();
            return;
        }
    }

}
