
import java.lang.*;
import java.util.*;
import java.awt.*;
import java.awt.image.*;

class TransparentPixelFilter extends RGBImageFilter {

    TransparentPixelFilter() {
        canFilterIndexColorModel = true;
    }

    public int filterRGB (int x, int y, int rgb) {

        int newRGB = rgb;

        if (rgb == 0xffffffff) {
            newRGB = 0x00ffffff; // transparent out the whites
                              // this could probably be done
                              // by changing the color model
                              // to IndexColorModel but I havent
                              // been able to figure out exatly
                              // how yet...
        }
        return newRGB;
    }

    public IndexColorModel filterIndexColorModel(IndexColorModel icm) {

        int mapSize = icm.getMapSize();

        byte reds[] = new byte[mapSize];
        byte greens[] = new byte[mapSize];
        byte blues[] = new byte[mapSize];
       byte alphas[] = new byte[mapSize];
  System.out.println("Transparent pixel = " + icm.getTransparentPixel());

        icm.getReds(reds);
        icm.getGreens(greens);
        icm.getBlues(blues);
   //     icm.getAlphas(alphas);

        return new IndexColorModel (
                      icm.getPixelSize(),
                      icm.getMapSize(),
                      reds,
                      greens,
                      blues,
          //            alphas);
                      icm.getTransparentPixel());
    }

}