import java.lang.*;
import java.util.*;

class VendingMachine {

	/*
	*/
	private CoinReturnButton coinReturnButton_;
	public CoinReturnButton coinReturnButton() { return coinReturnButton_; }
	public void coinReturnButton( CoinReturnButton aCoinReturnButton ) { coinReturnButton_ = aCoinReturnButton; }

	/*
	*/
	private MoneySlot moneySlot_;
	public MoneySlot moneySlot() { return moneySlot_; }
	public void moneySlot( MoneySlot aMoneySlot ) { moneySlot_ = aMoneySlot; }

	/*
	*/
	private Dispenser dispenser_;
	public Dispenser dispenser() { return dispenser_; }
	public void dispenser( Dispenser aDispenser ) { dispenser_ = aDispenser; }

	VendingMachine() {
	    this.initialize();
	}

	private void initialize() {
	    this.dispenser(new Dispenser());
	    this.coinReturnButton(new CoinReturnButton());
	    this.moneySlot(new MoneySlot());

	    // the extra hooks

	    this.moneySlot().coinCounter(this.dispenser().coinCounter());
	    this.moneySlot().coinBucket (this.coinReturnButton().coinBucket());

        this.dispenser().coinCounter().coinBucket(
                    this.coinReturnButton().coinBucket());


       this.coinReturnButton().coinBucket().addObserver(this.dispenser().coinCounter());
	}

	public void powerOn() {
	}
}
