import java.awt.*;
import java.lang.*;
import java.text.*;
import java.util.*;
import java.awt.event.*;

public class VideoPricerView extends SCView {

	/**
	 */
	private VideoStore videoStore_;
	private VideoStore videoStore() { return videoStore_; }
	private void videoStore( VideoStore aVideoStore ) { videoStore_ = aVideoStore; }


    VideoPricerView(VideoStore aVideoStore){
        super("Video Pricer View");
        this.videoStore( aVideoStore );
        this.initialize();
    }

    private void initialize() {

        this.initMenu();
        this.initLists();
        this.initLabels();
    //    this.initButtons();
        this.initTextFields();


        Enumeration enum = this.videoStore().promotionNames();
        while( enum.hasMoreElements() ){
            ((List) this.getWidget("promotionList")).
                addItem( (String) enum.nextElement() );
        }

        enum = this.videoStore().tapes();
        while( enum.hasMoreElements() ){
            Tape aTape = (Tape) enum.nextElement();
            String tapeString = aTape.id() + "  " + aTape.title();
            ((List) this.getWidget("tapeList")).
                addItem( tapeString );
        }

        this.setSize(600,350);
        this.setLocation(200,200);


    }

    private void initTextFields(){
        TextField aTextField = new TextField();
        aTextField.setSize(100,25);
        aTextField.setLocation(40,75);
        this.addWidget("customerIDTextField", aTextField);
    }
    private void initMenu(){
        MenuBar aMenuBar = new MenuBar();

            Menu aMenu = new Menu("File");

                MenuItem aMenuItem = new MenuItem("Exit");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Exit");
                aMenu.add(aMenuItem);

            aMenuBar.add(aMenu);

        this.setMenuBar(aMenuBar);

    }

    private void initLists(){

        List aList = new List();
        aList.setSize(210,100);
        aList.setLocation(20,130);
        aList.setMultipleMode(true);
        aList.addItemListener(this);
        this.addWidget("tapeList",aList);

        aList = new List();
        aList.setSize(300,100);
        aList.setLocation(280,100);
        aList.setMultipleMode(true);
        aList.addItemListener(this);
        this.addWidget("promotionList",aList);

    }

    private void initLabels(){

        Font bigFont = new Font("Helvetica",Font.BOLD,20);
        Font mediumFont = new Font("Helvetica",Font.BOLD,14);
        Font smallFont = new Font("Helvetica",Font.BOLD,10);

        Label aLabel = new Label("Customer ID");
        aLabel.setFont( mediumFont );
        aLabel.setSize(100,30);
        aLabel.setLocation(40,45);
        this.addWidget("customerIDLabel",aLabel);

        aLabel = new Label("Tapes");
        aLabel.setFont( mediumFont );
        aLabel.setSize(80,30);
        aLabel.setLocation(40,100);
        this.addWidget("tapeListLabel",aLabel);

        aLabel = new Label("Promotions in Effect");
        aLabel.setFont( mediumFont );
        aLabel.setSize(200,30);
        aLabel.setLocation(300,60);
        this.addWidget("promotionListLabel",aLabel);

        aLabel = new Label("Charge to Customer");
        aLabel.setFont( mediumFont );
        aLabel.setSize(140,30);
        aLabel.setLocation(40,240);
        this.addWidget("chargeToCustomerLabel",aLabel);

        aLabel = new Label("0.00");
        aLabel.setFont( mediumFont );
        aLabel.setSize(110,30);
        aLabel.setLocation(40,275);
        this.addWidget("chargeLabel",aLabel);

    }

    public void transactionComplete(){
        System.out.println("transactionComplete in VideoPricerView");
    }
    public void actionPerformed(ActionEvent e){
        String command = (String) e.getActionCommand();
        if(command == "Transaction Complete"){
            this.transactionComplete();
            return;
        }
        if(command == "Exit"){
            this.exit();
            return;
        }
    }
    public void itemStateChanged( ItemEvent ie ){

        System.out.println("itemStateChanged in VideoPricerView");
        System.out.println(((List) this.getWidget("tapeList")).getSelectedItems());

        Vector tapeIDs = new Vector();

        String items[] = ((List) this.getWidget("tapeList")).getSelectedItems();
        if( items.length == 0 ) {
            ((Label) this.getWidget("chargeLabel")).setText("0.00");
            return;
        }

        for( int i = 0; i < items.length; i++ ){
            String s = items[i].substring(0,9);
            tapeIDs.addElement( s );
        }

        Vector promotionNames = new Vector();
        items = ((List) this.getWidget("promotionList")).getSelectedItems();
        for( int i = 0; i < items.length; i++ ){
            promotionNames.addElement( items[i] );
        }

        String customerID = ((TextField) this.getWidget("customerIDTextField")).getText();
        double price =
            this.videoStore().calculatePrice( tapeIDs, promotionNames, customerID );


            NumberFormat theNF = NumberFormat.getCurrencyInstance();
        String result = theNF.format(price);


        ((Label) this.getWidget("chargeLabel")).setText(result);
        System.out.println("and the price is...   " + price);

    }
    public void windowClosing(WindowEvent e){
        this.exit();
    }

    private void exit(){
        this.hide();
    }

}
