import java.awt.*;
import java.lang.*;
import java.util.*;
import java.awt.event.*;

public class VideoStoreView extends SCView {

	/**
	 *  The VideoStore is the main object in the Business Model.
	 */
	private VideoStore videoStore_;
	private VideoStore videoStore() { return videoStore_; }
	private void videoStore( VideoStore aVideoStore ) { videoStore_ = aVideoStore; }

    VideoStoreView(VideoStore aVideoStore){
        super("Video Store View");
        this.videoStore( aVideoStore );
        this.initialize();
    }

    public static void main(String args[]){

        VideoStore aVideoStore = new VideoStore();

        VideoStoreView theView = new VideoStoreView( aVideoStore );

        theView.show();
    }

    private void initialize() {

        this.initMenu();

        VideoPricerView aVPV = new VideoPricerView(this.videoStore());
        this.addSubView("promotionPricer", aVPV);

        this.setSize(400,200);
        this.setLocation(200,200);


    }

    private void initMenu(){
        MenuBar aMenuBar = new MenuBar();

            Menu aMenu = new Menu("File");

                MenuItem aMenuItem = new MenuItem("Exit");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Exit");
                aMenu.add(aMenuItem);

            aMenuBar.add(aMenu);
            aMenu = new Menu("Open");

                aMenuItem = new MenuItem("Promotion Pricer");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Promotion Pricer");
                aMenu.add(aMenuItem);

            aMenuBar.add(aMenu);

        this.setMenuBar(aMenuBar);

    }
    public void openPromotionPricer(){
        this.getSubView("promotionPricer").show();
    }

    public void transactionComplete(){
        System.out.println("transactionComplete in VideoPricerView");
    }
    public void actionPerformed(ActionEvent e){
        String command = (String) e.getActionCommand();
        if(command == "Exit"){
            this.exit();
            return;
        }
        if(command == "Promotion Pricer"){
            this.openPromotionPricer();
            return;
        }

    }
    public void windowClosing(WindowEvent e){
        this.exit();
    }

    private void exit(){
        System.out.println("exit in VideoStoreView");
        this.dispose();
        System.exit(0);
    }

}
