/*+========================================================================+*/
/*| [FBN ARS     ], Copyright [1999] [FBN Software]  All Rights Reserved.  |*/
/*|------------------------------------------------------------------------|*/
/*| NOTE: This software contains valuable trade secrets and proprietary    |*/
/*| information of [FBN Software] and is protected by law. It may not be   |*/
/*| copied or distributed in any form or medium, disclosed to third        |*/
/*| parties, reverse engineered or used in any manner without prior        |*/
/*| written authorization from [FBN Software].                             |*/
/*|------------------------------------------------------------------------|*/
/*| FILE: View.java                                                        |*/
/*|------------------------------------------------------------------------|*/
/*| MODULE:                                                                |*/
/*|------------------------------------------------------------------------|*/
/*| Who | Date       | Description                                         |*/
/*|------------------------------------------------------------------------|*/
/*|  P+ | Nov 29, 99 | Last Code Generation                                |*/
/*+========================================================================+*/
import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class View extends SCView {

    private  FlyByNiteReservationSystem reservationSystem_;
    public FlyByNiteReservationSystem reservationSystem() { return reservationSystem_; }
    public void reservationSystem(FlyByNiteReservationSystem aFlyByNiteReservationSystem) { reservationSystem_ = aFlyByNiteReservationSystem; }

    public static void main(String argv[]){

        System.out.println("FBN ARS begins ..");
        View theBerniceView = new View();
        theBerniceView.show();
    }


    View () {
        super("Fly By Night Reservation System");
        this.initialize();
    }

    private void initialize() {

        // initialize
        this.reservationSystem( new FlyByNiteReservationSystem());
        this.setSize(300, 300);
        this.setLocation(30, 30);
        this.initMenu();

        // setup the subviews
        TravelPlanGeneratorView aTPGView =
                   new TravelPlanGeneratorView(this.reservationSystem());
        this.addSubView("TravelPlanGeneratorView", aTPGView);
   }

    private void initMenu(){
        MenuBar aMenuBar = new MenuBar();

            Menu aMenu = new Menu("File");

                MenuItem aMenuItem = new MenuItem("Exit");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Exit");
                aMenu.add(aMenuItem);

            aMenuBar.add(aMenu);

            aMenu = new Menu("Edit");

                aMenuItem = new MenuItem("Cut");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Cut");
                aMenu.add(aMenuItem);

                aMenuItem = new MenuItem("Copy");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Copy");
                aMenu.add(aMenuItem);

                aMenuItem = new MenuItem("Paste");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Paste");
                aMenu.add(aMenuItem);

            aMenuBar.add(aMenu);

            aMenu = new Menu("View");

                aMenuItem = new MenuItem("Flight Legs");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("FlightLegs");
                aMenu.add(aMenuItem);

                /*
                aMenuItem = new MenuItem("URL Rankings");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("URLRankings");
                aMenu.add(aMenuItem);
                */

            aMenuBar.add(aMenu);

            aMenu = new Menu("Tool");

                aMenuItem = new MenuItem("Generate Travel Plans");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("GenerateTravelPlans");
                aMenu.add(aMenuItem);

                /*
                aMenuItem = new MenuItem("URL Rankings");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("URLRankings");
                aMenu.add(aMenuItem);
                */

            aMenuBar.add(aMenu);



        this.setMenuBar(aMenuBar);

    }

    public void openTralvelPlanGenerator(){
        this.getSubView("TravelPlanGeneratorView").show();
    }

    public void actionPerformed(ActionEvent e){
        String command = (String) e.getActionCommand();
        if(command == "Exit"){
            this.exit();
            return;
        }
        if(command == "GenerateTravelPlans"){
            this.openTralvelPlanGenerator();
            return;
        }

    }


    public void windowClosing(WindowEvent e){
        this.exit();
    }

    private void exit(){
        this.hide();
        System.exit(0);
    }

}

