import java.awt.*;
import java.awt.event.*;
import java.util.*;

class ATMView extends SCView {

	/**
	 *  The ATM associated with this View
	 */
	private ATM atm_;
	public ATM atm() { return atm_; }
	public void atm( ATM anATM ) { atm_ = anATM; }



    private ATMView(){
        super("ATM View");
        this.initialize();
    }

    public static void main(String argv[]){

        ATMView theATMView = new ATMView();
        theATMView.show();

    }

    private void initialize(){

        this.atm(new ATM());
        this.atm().addObserver(this);

        this.setLayout(null);

        this.initMenu();
        this.initWidgets();

        this.setSize(300,300);
        this.setLocation(80,80);

    }
    private void initWidgets(){
        // Label's

        Label aLabel = new Label("PIN");
        aLabel.setSize(80,25);
        aLabel.setLocation(20,80);
        this.addWidget("pin label", aLabel);

        aLabel = new Label("Type of Transaction");
        aLabel.setSize(180,25);
        aLabel.setLocation(140,80);
        this.addWidget("type label", aLabel);

        aLabel = new Label("Name");
        aLabel.setSize(80,25);
        aLabel.setLocation(20,140);
        this.addWidget("account label", aLabel);

        aLabel = new Label("Amount");
        aLabel.setSize(180,25);
        aLabel.setLocation(140,140);
        this.addWidget("amount label", aLabel);

        // TextField's
        TextField aTextField = new TextField();
        aTextField.setSize(100,25);
        aTextField.setLocation(20,105);
        this.addWidget("pin textField",aTextField);

        aTextField = new TextField();
        aTextField.setSize(100,25);
        aTextField.setLocation(20,165);
        this.addWidget("account number textField",aTextField);

        aTextField = new TextField();
        aTextField.setSize(100,25);
        aTextField.setLocation(140,165);
        this.addWidget("amount textField",aTextField);

        // Choice's
        Choice c = new Choice();
        c.addItem("Withdrawl");
        c.addItem("Deposit");
        c.setSize(100,30);
        c.setLocation(140,105);
        this.addWidget("transaction type choice", c);




    }

    private void sendTransaction(){
        try{

        String transactionType =    ((Choice) this.getWidget("transaction type choice")).getSelectedItem();
        String pin =                ((TextField) this.getWidget("pin textField")).getText();
        String accountNumber =      ((TextField) this.getWidget("account number textField")).getText();
        String amount =             ((TextField) this.getWidget("amount textField")).getText();

        if(transactionType.equals("Deposit")){
            System.out.println("deposit");
            this.atm().enterDeposit(accountNumber, pin, (Double.valueOf(amount)).doubleValue());

        }
        else{
            System.out.println("withdrawl");
        this.atm().enterWithdrawal(accountNumber, pin, (Double.valueOf(amount)).doubleValue());

        }


        System.out.println("sendTransaction in ATMView");


        System.out.println("PIN " + pin);
        System.out.println("Acount Number " + accountNumber);
        System.out.println("Amount " + amount);
        System.out.println("Transaction Type " + transactionType);
        }
        catch(Exception e){
            System.out.println("exception caught in sendTransaction");
        }
    }


    public void update(Observable obs, Object o) {
        String theString = (String) o;
        System.out.println(">> " + theString);
    }

   public void actionPerformed(ActionEvent e){
        String actionCommand = e.getActionCommand();
        if( actionCommand.equals("Exit") ){
            this.exit();
            return;
        }
        if( actionCommand.equals("Send Transaction") ){
            this.sendTransaction();
            return;
        }
    }

    private void initMenu(){
        MenuBar aMenuBar = new MenuBar();
            Menu aMenu = new Menu("File");
                MenuItem aMenuItem = new MenuItem("Exit");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Exit");
            aMenu.add(aMenuItem);
            aMenuBar.add(aMenu);

            aMenu = new Menu("Action");
                aMenuItem = new MenuItem("Send Transaction");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Send Transaction");
            aMenu.add(aMenuItem);

            aMenuBar.add(aMenu);

        this.setMenuBar(aMenuBar);
    }
    public void windowClosing(WindowEvent we){
        this.exit();
    }



    private void exit(){
        System.out.println("closing ATMView");
        try{ Thread.sleep(500); }
        catch(InterruptedException ie){}
        this.dispose();
        System.exit(0);
    }

}

