
import java.util.*;

public class Withdrawal extends Transaction {

    Withdrawal() {
        this.initialize();
    }

    Withdrawal(Account anAccount, double amount) {
        this();
        this.account(anAccount);
        this.amount(amount);
    }

    private void initialize() {
        this.timestamp(new Date());
        this.account(new Account());
        this.amount(0.0);
    }

    public void perform() {
        double currentBalance = this.account().balance();
        if (this.amount() > currentBalance) {
            System.out.println("Exceeds funds available");
            return;
        }
        this.account().balance(this.account().balance() - this.amount());

    }
}