import java.util.*;
import java.awt.*;
import java.io.*;

public class CarImageFinder {

    private static CarImageFinder instance_ = null;

    public synchronized static CarImageFinder instance() {
        if (instance_ == null)
            instance_ = new CarImageFinder();
        return instance_;
    }

	/**
	 *  Hashtable containing the car images. The key for a car
	 *  is "carnnn" where nnn is a multiple of 10 between 0
	 *  and 350 (degrees) inclusive
	 */
	private Hashtable carImages_;
	public Hashtable carImages() { return carImages_; }
	public void carImages( Hashtable anHashtable ) { carImages_ = anHashtable; }

    private CarImageFinder() {
        this.initialize();
    }

    private void initialize() {
        this.carImages(new Hashtable());
        this.carImages().put("car000", Toolkit.getDefaultToolkit().getImage("car000.GIF"));
        this.carImages().put("car010", Toolkit.getDefaultToolkit().getImage("car010.GIF"));
        this.carImages().put("car020", Toolkit.getDefaultToolkit().getImage("car020.GIF"));
        this.carImages().put("car030", Toolkit.getDefaultToolkit().getImage("car030.GIF"));
        this.carImages().put("car040", Toolkit.getDefaultToolkit().getImage("car040.GIF"));
        this.carImages().put("car050", Toolkit.getDefaultToolkit().getImage("car050.GIF"));
        this.carImages().put("car060", Toolkit.getDefaultToolkit().getImage("car060.GIF"));
        this.carImages().put("car070", Toolkit.getDefaultToolkit().getImage("car070.GIF"));
        this.carImages().put("car080", Toolkit.getDefaultToolkit().getImage("car080.GIF"));
        this.carImages().put("car090", Toolkit.getDefaultToolkit().getImage("car090.GIF"));
        this.carImages().put("car100", Toolkit.getDefaultToolkit().getImage("car100.GIF"));
        this.carImages().put("car110", Toolkit.getDefaultToolkit().getImage("car110.GIF"));
        this.carImages().put("car120", Toolkit.getDefaultToolkit().getImage("car120.GIF"));
        this.carImages().put("car130", Toolkit.getDefaultToolkit().getImage("car130.GIF"));
        this.carImages().put("car140", Toolkit.getDefaultToolkit().getImage("car140.GIF"));
        this.carImages().put("car150", Toolkit.getDefaultToolkit().getImage("car150.GIF"));
        this.carImages().put("car160", Toolkit.getDefaultToolkit().getImage("car160.GIF"));
        this.carImages().put("car170", Toolkit.getDefaultToolkit().getImage("car170.GIF"));
        this.carImages().put("car180", Toolkit.getDefaultToolkit().getImage("car180.GIF"));
        this.carImages().put("car190", Toolkit.getDefaultToolkit().getImage("car190.GIF"));
        this.carImages().put("car200", Toolkit.getDefaultToolkit().getImage("car200.GIF"));
        this.carImages().put("car210", Toolkit.getDefaultToolkit().getImage("car210.GIF"));
        this.carImages().put("car220", Toolkit.getDefaultToolkit().getImage("car220.GIF"));
        this.carImages().put("car230", Toolkit.getDefaultToolkit().getImage("car230.GIF"));
        this.carImages().put("car240", Toolkit.getDefaultToolkit().getImage("car240.GIF"));
        this.carImages().put("car250", Toolkit.getDefaultToolkit().getImage("car250.GIF"));
        this.carImages().put("car260", Toolkit.getDefaultToolkit().getImage("car260.GIF"));
        this.carImages().put("car270", Toolkit.getDefaultToolkit().getImage("car270.GIF"));
        this.carImages().put("car280", Toolkit.getDefaultToolkit().getImage("car280.GIF"));
        this.carImages().put("car290", Toolkit.getDefaultToolkit().getImage("car290.GIF"));
        this.carImages().put("car300", Toolkit.getDefaultToolkit().getImage("car300.GIF"));
        this.carImages().put("car310", Toolkit.getDefaultToolkit().getImage("car310.GIF"));
        this.carImages().put("car320", Toolkit.getDefaultToolkit().getImage("car320.GIF"));
        this.carImages().put("car330", Toolkit.getDefaultToolkit().getImage("car330.GIF"));
        this.carImages().put("car340", Toolkit.getDefaultToolkit().getImage("car340.GIF"));
        this.carImages().put("car350", Toolkit.getDefaultToolkit().getImage("car350.GIF"));
    }

    public Enumeration elements() {
        return this.carImages().elements();
    }


    public Image findImageFor(Track aTrack) {
        return (Toolkit.getDefaultToolkit().getImage("car000.GIF"));
    }

    public Image findImage(String aKey) {
        return ((Image) (this.carImages().get(aKey)));
    }


    public static void writeToFile(String aName, Hashtable theFrames) {

        try {
            PrintStream theFile = new PrintStream (new FileOutputStream
                                   (aName + ".txt"));
            Enumeration theCollection = theFrames.keys();

            while (theCollection.hasMoreElements()) {
                String theKey = (String) theCollection.nextElement();
                TravelerFrame theTravelerFrame = (TravelerFrame) theFrames.get(theKey);
                int x = theTravelerFrame.position().x;
                int y = theTravelerFrame.position().y;

                theFile.println(theKey + " " + x + " " + y + " " + theTravelerFrame.angle());
            }

            theFile.close();
        }
        catch(IOException e) {}
    }
}
