import java.util.*;

class Lane implements Comparable, Observer {

	/**
	 */
	private LightBox lightBox_;
	public LightBox lightBox() { return lightBox_; }
	public void lightBox( LightBox aLightBox ) { lightBox_ = aLightBox; }

	/**
	 */
	private TrafficLiteController trafficLiteController_;
	public TrafficLiteController trafficLiteController() { return trafficLiteController_; }
	public void trafficLiteController( TrafficLiteController aTrafficLiteController ) { trafficLiteController_ = aTrafficLiteController; }

	/**
	 */
	private GreenRequest greenRequest_;
	public GreenRequest greenRequest() { return greenRequest_; }
	public void greenRequest( GreenRequest aGreenRequest ) { greenRequest_ = aGreenRequest; }

	/**
	 *  the Lane objects in this vector cannot be
	 *  turned green at the same time as this Lane
	 */
	private Vector conflictingLanes_;
	public Vector conflictingLanes() { return conflictingLanes_; }
	public void conflictingLanes( Vector aVector ) { conflictingLanes_ = aVector; }

    Lane( TrafficLiteController tlc ){
        this.conflictingLanes( new Vector() );
        this.trafficLiteController(tlc);
    }
    public boolean goingGreen(){
        return this.lightBox().goingGreen;
    }
    public void sensorActivated(){
        System.out.println("we should not be here in sensorActivated in Lane");
    }
    public void update(Observable obs, Object o){
       // this.trafficLiteController().updateLight("whatTheFuck?",(String) o);
    }
    public boolean mustKeepFlowing(){
        return this.lightBox().mustKeepFlowing();
    }
    public void heartBeat(){
        this.lightBox().heartBeat();
    }
    public void setConflictingLanes(Vector lanes){
        this.conflictingLanes(lanes);
    }
    public void setConflicts(){
        System.out.println("setConflicts in Lane, should not be called");
    }
    public int compare( Lane aLane ){
        return aLane.greenRequest().time().compareTo(
                    this.greenRequest().time());

    }

    public boolean conflictsWith( Lane aLane ){
        return this.conflictingLanes().contains( aLane );
    }
    public boolean doesNotConflictWith( Vector lanes ){
        Lane aLane;
        Enumeration someLanes = lanes.elements();
        while( someLanes.hasMoreElements() ){
            aLane = (Lane) someLanes.nextElement();
            if( this.conflictsWith( aLane ) ){
                return false;
            }
        }
        return true;
    }
    public void goRed(){
        this.lightBox().goRed();
    }
    public void goGreen(){
   //     System.out.println("goGreen in Lane");
        this.lightBox().goGreen();
      //  this.greenRequest( null );
    }
    public void go(){
       // this.lightBox().go();
    }
    public void stop(){
       // this.lightBox().stop();
    }
    public boolean isGreen(){
        return this.lightBox().isGreen();
    }
    public boolean isRed(){
        return this.lightBox().isRed();
    }

    public int compare( Comparable c ){
        return this.greenRequest().time().compareTo(
            ((Lane) c).greenRequest().time());
    }

    public boolean hasGreenRequest(){
        if( this.greenRequest() == null ){
            return false;
        }
        return true;
    }
}