import java.util.*;
import java.lang.*;

class Zoo extends Observable {

    private String name_;
    public String name() { return name_; }
    public void name(String aName) {name_ = aName; }

    private Vector zooKeepers_;
    public Vector zooKeepers() { return zooKeepers_; }
    public void zooKeepers(Vector theKeepers) { zooKeepers_ = theKeepers; }

    Zoo() {
        this.initialize();
    }

    private void initialize() {
        this.zooKeepers(new Vector());
        this.name("Fred's Zoo");
        Vector theZKs  = this.zooKeepers();

        // ZooKeeper One

        ZooKeeper aZooKeeper = new ZooKeeper("George");
        theZKs.addElement(aZooKeeper);

        Vector theAnimals = new Vector();
        theAnimals.addElement(new Animal("George", 2));
        theAnimals.addElement(new Animal("Centi",  43));

        aZooKeeper.animals(theAnimals);

        // ZooKeeper Two

        aZooKeeper = new ZooKeeper("Bill");
        theZKs.addElement(aZooKeeper);

        theAnimals = new Vector();
        theAnimals.addElement(new Animal("Wormy",  0));
        theAnimals.addElement(new Animal("Yogi",   4));

        aZooKeeper.animals(theAnimals);

    }

    public void computeFootCount() {
        int totalFootCount = 0;
        Enumeration theZooKeepers = this.zooKeepers().elements();
        while (theZooKeepers.hasMoreElements()) {
            ZooKeeper aZooKeeper = (ZooKeeper) theZooKeepers.nextElement();
            totalFootCount = totalFootCount +
                                aZooKeeper.computeTotalFootCount();
        }
        this.publicize("Total Foot Count =  " + totalFootCount);
    }


    public void publicize(String aString) {
        this.setChanged();
        this.notifyObservers(aString);
    }

}


