import java.awt.*;
import java.awt.event.*;
import java.util.*;

class HomeworkPackerView extends SCView {

    private FontMetrics fontMetrics;

	/**
	 *  this would be the business model
	 */
	private HomeworkPacker homeworkPacker_;
	private HomeworkPacker homeworkPacker() { return homeworkPacker_; }
	private void homeworkPacker( HomeworkPacker anHomeworkPacker ) { homeworkPacker_ = anHomeworkPacker; }

    private HomeworkPackerView(){
        super("Homework Packer View");
        this.initialize();
    }

    public static void main(String argv[]){
        HomeworkPackerView theHomeworkPackerView = new HomeworkPackerView();
        theHomeworkPackerView.show();
    }

    private void initialize(){

        this.setLayout(null);

        this.homeworkPacker( new HomeworkPacker() );
        this.homeworkPacker().addObserver(this);

        this.initMenu();

        this.fontMetrics = Toolkit.getDefaultToolkit().getFontMetrics(new Font("Courier",0,14));

        this.initWidgets();

        this.setSize(710,530);
        this.setLocation(80,80);

    }


    private void sourceChosen(){
        DirectoryDialog dd = new DirectoryDialog(this);
        dd.show();

        String sourceDirectory = dd.getChosenFile().getPath();

        this.homeworkPacker().setSourceDirectory( sourceDirectory );

        this.setSourceLabel(sourceDirectory);

    }
    private void destinationChosen(){
        DirectoryDialog dd = new DirectoryDialog(this);
        dd.show();

        String destinationDirectory = dd.getChosenFile().getPath();

        this.homeworkPacker().setDestinationDirectory( destinationDirectory );

        this.setDestinationLabel(destinationDirectory);

    }

        //////////////////////////////////////////////////////
       //////////////////////////////////////////////////////
      //////////////   here be the good stuff   ////////////
     //////////////////////////////////////////////////////
    //////////////////////////////////////////////////////

    private void packItUp(){

        this.setCursor(new Cursor(Cursor.WAIT_CURSOR));

        this.homeworkPacker().setName(((TextField) this.getWidget("enter name TextField")).getText());
        this.homeworkPacker().setComment(((TextArea) this.getWidget("comment TextArea")).getText());
        this.homeworkPacker().setMainClass(((TextField) this.getWidget("main class TextField")).getText());
        this.homeworkPacker().setFileName(((TextField) this.getWidget("file name TextField")).getText());

        ((TextArea) this.getWidget("comment TextArea")).setText("");

        this.homeworkPacker().createFile();
        try{ Thread.sleep(2000); }
        catch(InterruptedException ie){}
        ((TextArea) this.getWidget("comment TextArea")).setText(this.homeworkPacker().getComment());
        this.setCursor(Cursor.getDefaultCursor());
    }

    private void initWidgets(){

        this.initSourceWidgets();
        this.initDestinationWidgets();
        this.initNameWidgets();
        this.initMainClassWidgets();
        this.initFileNameWidgets();
        this.initCommentWidgets();

    }

    private void initNameWidgets(){
        Label aLabel = new Label("What is your name?");
        aLabel.setSize(450,30);
        aLabel.setLocation(-80,125);
        aLabel.setFont(new Font("Courier",0,14));
        aLabel.setAlignment(Label.RIGHT);
        this.add(aLabel);

        TextField aTextField = new TextField();
        aTextField.setSize(220,30);
        aTextField.setLocation(385,125);
        aTextField.setFont(new Font("Courier",0,14));
      //  aTextField.setActionCommand("whatsyername");
        aTextField.addActionListener(this);
        this.addWidget("enter name TextField",aTextField);

    }
    private void initMainClassWidgets(){
        Label aLabel = new Label("Which class has main()?");
        aLabel.setSize(450,30);
        aLabel.setLocation(-80,160);
        aLabel.setFont(new Font("Courier",0,14));
        aLabel.setAlignment(Label.RIGHT);
        this.add(aLabel);

        TextField aTextField = new TextField();
        aTextField.setSize(220,30);
        aTextField.setLocation(385,160);
        aTextField.setFont(new Font("Courier",0,14));
      //  aTextField.setActionCommand("whatsyername");
       // aTextField.addActionListener(this);
        this.addWidget("main class TextField",aTextField);

    }

    private void initFileNameWidgets(){
        Label aLabel = new Label("Name the .jhw file");
        aLabel.setSize(450,30);
        aLabel.setLocation(-80,195);
        aLabel.setFont(new Font("Courier",0,14));
        aLabel.setAlignment(Label.RIGHT);
        this.add(aLabel);

        TextField aTextField = new TextField("hw52.jhw");
        aTextField.setSize(220,30);
        aTextField.setLocation(385,195);
        aTextField.setFont(new Font("Courier",0,14));
      //  aTextField.setActionCommand("whatsyername");
       // aTextField.addActionListener(this);
        this.addWidget("file name TextField",aTextField);

    }

    private void initSourceWidgets(){
        Label aLabel = new Label("Where are your .java files?");
        aLabel.setSize(450,30);
        aLabel.setLocation(-80,65);
        aLabel.setFont(new Font("Courier",0,14));
        aLabel.setAlignment(Label.RIGHT);
        this.add(aLabel);

        Button aButton = new Button("Browse");
        aButton.setSize(90,30);
        aButton.setLocation(385,65);
        aButton.setFont(new Font("Courier",0,14));
        aButton.setActionCommand("Source");
        aButton.addActionListener(this);
        this.add(aButton);

        aLabel = new Label("");
        aLabel.setSize(200,30);
        aLabel.setLocation(485,65);
        aLabel.setFont(new Font("Courier",0,14));
        aLabel.setAlignment(Label.RIGHT);
        this.addWidget("source directory Label",aLabel);



    }

    private void initDestinationWidgets(){
        Label aLabel = new Label("Where would you like the .jhw file to go?");
        aLabel.setSize(450,30);
        aLabel.setLocation(-80,95);
        aLabel.setFont(new Font("Courier",0,14));
        aLabel.setAlignment(Label.RIGHT);
        this.add(aLabel);

        Button aButton = new Button("Browse");
        aButton.setSize(90,30);
        aButton.setLocation(385,95);
        aButton.setFont(new Font("Courier",0,14));
        aButton.setActionCommand("Destination");
        aButton.addActionListener(this);
        this.add(aButton);

        aLabel = new Label("");
        aLabel.setSize(200,30);
        aLabel.setLocation(485,95);
        aLabel.setFont(new Font("Courier",0,14));
        aLabel.setAlignment(Label.RIGHT);
        this.addWidget("destination directory Label",aLabel);



    }

    private void initCommentWidgets(){

        String instructions = new String();
        instructions += "Jay's HomeworkPacker 1.0 is finally here.\n\n";
        instructions += "Just type over these instructions with any comments that you might have.\n";
        instructions += "\nI made the file dialogs that come up when you click one of the Browse buttons.\n";
        instructions += "The String above the list represents the File that will be returned.\n";
        instructions += "To choose a directory, choose done when the name of the directory\n";
        instructions += "you want is above the list, and the contents of that directory are shown in the list.\n";
        instructions += "\nChoose PackItUp from the File menu when everything is filled out.\n";
        instructions += "\nAttach the .jhw (Java-Home-Work) file to an email, instead of a .zip or anything else.\n";
        instructions += "For .gif files, make one .zip and use a second attachment.\n";
        instructions += "\nThis will speed up the homework code review.\n";
        instructions += "\nAdios, see you in class, Jay\n";

        TextArea ta = new TextArea(instructions);
        ta.setSize(600,300);
        ta.setLocation(50,225);
        this.addWidget("comment TextArea",ta);

    }

    public void update(Observable obs, Object o){
        ((TextArea) this.getWidget("comment TextArea")).append("\n" + (String) o);
    }

    private void initMenu(){
        MenuBar aMenuBar = new MenuBar();


            Menu aMenu = new Menu("File");
                MenuItem aMenuItem = new MenuItem("Pack it up");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Pack it up");
            aMenu.add(aMenuItem);
                aMenuItem = new MenuItem("Exit");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Exit");
            aMenu.add(aMenuItem);

        aMenuBar.add(aMenu);

        this.setMenuBar(aMenuBar);
    }

   public void actionPerformed(ActionEvent e){
        String actionCommand = e.getActionCommand();

        if( actionCommand.equals("Exit") ){
            this.exit();
            return;
        }
        if( actionCommand.equals("Source") ){
            this.sourceChosen();
        }
        if( actionCommand.equals("Destination") ){
            this.destinationChosen();
        }
        if( actionCommand.equals("Pack it up") ){
            this.packItUp();
        }
    }

    private void setSourceLabel(String newLabel){

     //   int newLabelWidth = this.fontMetrics.stringWidth(newLabel);

        if(this.fontMetrics.stringWidth(newLabel) > 190){
            ((Label) this.getWidget("source directory Label")).setAlignment(Label.RIGHT);
        }
        else{
            ((Label) this.getWidget("source directory Label")).setAlignment(Label.LEFT);
        }
        ((Label) this.getWidget("source directory Label")).setText(newLabel);
    }


    private void setDestinationLabel(String newLabel){

      //  int newLabelWidth = this.fontMetrics.stringWidth(newLabel);

        if(this.fontMetrics.stringWidth(newLabel) > 290){
            ((Label) this.getWidget("destination directory Label")).setAlignment(Label.RIGHT);
        }
        else{
            ((Label) this.getWidget("destination directory Label")).setAlignment(Label.LEFT);
        }
        ((Label) this.getWidget("destination directory Label")).setText(newLabel);
    }



    public void windowClosing(WindowEvent we){
        this.exit();
    }
    private void exit(){
        System.out.println("closing HomeworkPackerView");
        try{ Thread.sleep(500); }
        catch(InterruptedException ie){}
        this.dispose();
        System.exit(0);
    }

}

