
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class SysLog extends Frame implements WindowListener,
                                                ActionListener {

    public static void main(String argv[]){
        for(int i = 0; i<1000000; i++){
            S.p("here we go ===================================" + i);
           // SysLog.instance().update("here we go ===================================" + i);
            try{ Thread.sleep(200); }
            catch(InterruptedException ie){}
        }
    }

    private static SysLog instance_ = null;

    private boolean textAreaDisabled_;

    private boolean stringBufferDisabled_;

	private String stringBuffer_;

    private TextArea textArea_;

    private long maxTextAreaSize_;

    private long maxStringBufferSize_;

    private SysLog(){
        super( "System Log" );
        this.initialize();
        this.show();
    }
    public static SysLog instance() {
        if (instance_ == null)
            instance_ = new SysLog();
        return instance_;
    }

    private void initialize(){

        this.addWindowListener(this);

        this.initMenu();

        textArea_ = new TextArea();
        this.add(textArea_);

        maxTextAreaSize_ = 2000;
        maxStringBufferSize_ = 10000;

        textAreaDisabled_ = false;
        stringBufferDisabled_ = false;


        stringBuffer_ = new String();

        this.setSize(300,300);
        this.setLocation(100,100);
    }

    public void update(String s){

        s += "\n";

        if(!stringBufferDisabled_){
            if(stringBuffer_.length() > maxStringBufferSize_){
                stringBuffer_ = "";
            }
            else{
                stringBuffer_ += s ;
            }
        }
        if(!textAreaDisabled_){
            if(textArea_.getText().length() > maxTextAreaSize_){
                textArea_.setText("");
            }
            else{
                textArea_.append(s);
            }
        }
    }


    private void clear(){
        textArea_.setText("");
        stringBuffer_ = "";
    }
    private void initMenu(){

        MenuBar aMenuBar = new MenuBar();

            Menu aMenu = new Menu("File");

                MenuItem aMenuItem = new MenuItem("Exit");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Exit");
            aMenu.add(aMenuItem);

                aMenuItem = new MenuItem("Go Away Forever");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Go Away Forever");
            aMenu.add(aMenuItem);


        aMenuBar.add(aMenu);

            aMenu = new Menu("Configure");

                Menu bMenu = new Menu("Text Area Size");

                    aMenuItem = new MenuItem("500");
                    aMenuItem.addActionListener(this);
                    aMenuItem.setActionCommand("TAS500");
                bMenu.add(aMenuItem);

                    aMenuItem = new MenuItem("2K");
                    aMenuItem.addActionListener(this);
                    aMenuItem.setActionCommand("TAS2000");
                    aMenuItem.setEnabled(false);
                bMenu.add(aMenuItem);

                    aMenuItem = new MenuItem("10K");
                    aMenuItem.addActionListener(this);
                    aMenuItem.setActionCommand("TAS10000");
                bMenu.add(aMenuItem);

            aMenu.add(bMenu);

                bMenu = new Menu("String Buffer Size");

                    aMenuItem = new MenuItem("500");
                    aMenuItem.addActionListener(this);
                    aMenuItem.setActionCommand("SBS500");
                bMenu.add(aMenuItem);

                    aMenuItem = new MenuItem("2K");
                    aMenuItem.addActionListener(this);
                    aMenuItem.setActionCommand("SBS2000");
                bMenu.add(aMenuItem);

                    aMenuItem = new MenuItem("10K");
                    aMenuItem.addActionListener(this);
                    aMenuItem.setActionCommand("SBS10000");
                    aMenuItem.setEnabled(false);
                bMenu.add(aMenuItem);

                    aMenuItem = new MenuItem("100K");
                    aMenuItem.addActionListener(this);
                    aMenuItem.setActionCommand("SBS100K");
                bMenu.add(aMenuItem);

                    aMenuItem = new MenuItem("1Meg");
                    aMenuItem.addActionListener(this);
                    aMenuItem.setActionCommand("SBS1Meg");
                bMenu.add(aMenuItem);

            aMenu.add(bMenu);

        aMenuBar.add(aMenu);


            aMenu = new Menu("Action");

                aMenuItem = new MenuItem("Disable Text Area");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Disable Text Area");
            aMenu.add(aMenuItem);

                aMenuItem = new MenuItem("Enable Text Area");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Enable Text Area");
                aMenuItem.setEnabled(false);
            aMenu.add(aMenuItem);

                aMenuItem = new MenuItem("Disable String Buffer");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Disable String Buffer");
            aMenu.add(aMenuItem);

                aMenuItem = new MenuItem("Enable String Buffer");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Enable String Buffer");
                aMenuItem.setEnabled(false);
            aMenu.add(aMenuItem);

                aMenuItem = new MenuItem("Dump Buffer to SysLog");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Dump Buffer to SysLog");
            aMenu.add(aMenuItem);

                aMenuItem = new MenuItem("Dump Buffer to System.out");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Dump Buffer to System.out");
            aMenu.add(aMenuItem);

        aMenuBar.add(aMenu);

        this.setMenuBar(aMenuBar);
    }
   public void actionPerformed(ActionEvent e){
        String actionCommand = e.getActionCommand();
        if( actionCommand.equals("Exit") ){
            this.exit();
            return;
        }
        if( actionCommand.equals("Disable Text Area") ){
            this.textAreaDisabled_ = true;
            this.getMenuBar().getMenu(2).getItem(0).setEnabled(false);
            this.getMenuBar().getMenu(2).getItem(1).setEnabled(true);
            return;
        }
        if( actionCommand.equals("Disable String Buffer") ){
            this.stringBufferDisabled_ = true;
            this.getMenuBar().getMenu(2).getItem(2).setEnabled(false);
            this.getMenuBar().getMenu(2).getItem(3).setEnabled(true);
            return;
        }
        if( actionCommand.equals("Enable Text Area") ){
            this.textAreaDisabled_ = false;
            this.getMenuBar().getMenu(2).getItem(1).setEnabled(false);
            this.getMenuBar().getMenu(2).getItem(0).setEnabled(true);
            return;
        }
        if( actionCommand.equals("Enable String Buffer") ){
            this.stringBufferDisabled_ = false;
            this.getMenuBar().getMenu(2).getItem(3).setEnabled(false);
            this.getMenuBar().getMenu(2).getItem(2).setEnabled(true);
            return;
        }
        if( actionCommand.equals("Go Away Forever") ){
            this.goAwayForever();
            return;
        }
        if( actionCommand.equals("Clear") ){
            this.clear();
            return;
        }
        if( actionCommand.equals("SBS500") ){
            this.maxStringBufferSize_ = 500;
            this.enableAllSBSConfigureChoices();
            ((Menu) this.getMenuBar().getMenu(1).getItem(1)).getItem(0).setEnabled(false);
            return;
        }
        if( actionCommand.equals("SBS2000") ){
            this.maxStringBufferSize_ = 2000;
            this.enableAllSBSConfigureChoices();
            ((Menu) this.getMenuBar().getMenu(1).getItem(1)).getItem(1).setEnabled(false);
            return;
        }
        if( actionCommand.equals("SBS10000") ){
            this.maxStringBufferSize_ = 10000;
            this.enableAllSBSConfigureChoices();
            ((Menu) this.getMenuBar().getMenu(1).getItem(1)).getItem(2).setEnabled(false);
            return;
        }
        if( actionCommand.equals("SBS100K") ){
            this.maxStringBufferSize_ = 100000;
            this.enableAllSBSConfigureChoices();
            ((Menu) this.getMenuBar().getMenu(1).getItem(1)).getItem(3).setEnabled(false);
            return;
        }
        if( actionCommand.equals("SBS1Meg") ){
            this.maxStringBufferSize_ = 1000000;
            this.enableAllSBSConfigureChoices();
            ((Menu) this.getMenuBar().getMenu(1).getItem(1)).getItem(4).setEnabled(false);
            return;
        }
        if( actionCommand.equals("TAS500") ){
            this.maxTextAreaSize_ = 500;
            this.enableAllTASConfigureChoices();
            ((Menu) this.getMenuBar().getMenu(1).getItem(0)).getItem(0).setEnabled(false);
            return;
        }
        if( actionCommand.equals("TAS2000") ){
            this.maxTextAreaSize_ = 2000;
            this.enableAllTASConfigureChoices();
            ((Menu) this.getMenuBar().getMenu(1).getItem(0)).getItem(1).setEnabled(false);
            return;
        }
        if( actionCommand.equals("TAS10000") ){
            this.maxTextAreaSize_ = 10000;
            this.enableAllTASConfigureChoices();
            ((Menu) this.getMenuBar().getMenu(1).getItem(0)).getItem(2).setEnabled(false);
            return;
        }
        if( actionCommand.equals("Dump Buffer to SysLog") ){
            this.textArea_.setText(this.stringBuffer_);
            return;
        }
        if( actionCommand.equals("Dump Buffer to System.out") ){
            System.out.println(this.stringBuffer_);
            return;
        }
    }

    private void enableAllSBSConfigureChoices(){
        for(int i = 0; i < 5; i++){
            ((Menu) this.getMenuBar().getMenu(1).getItem(1)).getItem(i).setEnabled(true);
        }
    }
    private void enableAllTASConfigureChoices(){
        for(int i = 0; i < 3; i++){
            ((Menu) this.getMenuBar().getMenu(1).getItem(0)).getItem(i).setEnabled(true);
        }
    }

    public void windowClosing(WindowEvent we){
        this.exit();
    }
    private void goAwayForever(){
        System.out.println("SysLog is going away forever");
        S.quit();
        try{ Thread.sleep(500); }
        catch(InterruptedException ie){}
        instance_ = null;
        this.dispose();
    }

    private void exit(){
        System.out.println("closing SysLog");
        try{ Thread.sleep(500); }
        catch(InterruptedException ie){}
        instance_ = null;
        this.dispose();
      //  System.exit(0);
    }
    // support WindowListener interface
    public void windowActivated(WindowEvent e){}
    public void windowClosed(WindowEvent e){}
  //  public void windowClosing(WindowEvent e){}
    public void windowOpened(WindowEvent e){}
    public void windowDeactivated(WindowEvent e){}
    public void windowIconified(WindowEvent e){}
    public void windowDeiconified(WindowEvent e){}

}
